
ChiliProject - Bug # 178: Multiselect issues on Mac

Status: Closed Priority: Normal
Author: S C Category: User interface
Created: 2011-02-11 Assignee:
Updated: 2011-02-27 Due date:
Remote issue URL:
Affected version:
Description: When I try to select multiple issues on OS X, I use the command key instead of the control key.

But it's not supported.

So here is a very tiny patch to handle it.

Associated revisions
2011-02-18 10:42 am - Felix SchÃ¤fer 
Allow issue multiselect on Mac. #178

Contributed by Simon COURTOIS

History
2011-02-11 05:57 pm - Felix Schäfer
Mmh, I've always used the checkboxes for that and didn't even know you could multiselect them that way :-) Does this present any drawbacks for other 
browsers/platforms?

2011-02-11 06:34 pm - S C
To be honest, I just don't know. I guess not since it's pretty specific, but I can't be sure.

2011-02-11 06:59 pm - Holger Just
According to http://unixpapa.com/js/key.html, @metaKey@ is available on all current browsers on the Mac. But it is undefined on IE. Would need to 
check there if that fails.

2011-02-11 10:15 pm - Felix Schäfer
Holger Just wrote:
> According to http://unixpapa.com/js/key.html, @metaKey@ is available on all current browsers on the Mac. 

Funny thing: Safari doesn't care, I still get the context menu when clicking on stuff, even with the patch and the command key pressed. Firefox for mac 
does a multiselect with the command key though.

> But it is undefined on IE. Would need to check there if that fails.

Just tried it with IE8: ctrl+select still does a multiselect (as expected), so I _guess_ it will be OK on earlier versions too if they didn't change too much 
around that.

2011-02-15 02:31 pm - Felix Schäfer
- Status changed from Open to Ready for review

Ok, Holger found out that "cmd+click" in Safari sends a middle click and a "metaKey", not a left click and "metaKey". We've changed the check for left 
click to a check for not right click, and that seems to work as expected on Safari/OSX, Firefox/OSX and IE8/Win7.

<pre><code class="diff">diff --git a/public/javascripts/context_menu.js b/public/javascripts/context_menu.js
index 4bb73ee..2e582d9 100644
--- a/public/javascripts/context_menu.js
+++ b/public/javascripts/context_menu.js
@@ -40,7 +40,7 @@ ContextMenu.prototype = {
        this.hideMenu();
        if (Event.element(e).tagName == 'A') { return; }
     if (window.opera && e.altKey) {    return; }
-    if (Event.isLeftClick(e) || (navigator.appVersion.match(/\bMSIE\b/))) {      
+    if (!Event.isRightClick(e) || (navigator.appVersion.match(/\bMSIE\b/))) {      
       var tr = Event.findElement(e, 'tr');
       if (tr!=null && tr!=document && tr.hasClassName('hascontextmenu')) {
         // a row was clicked, check if the click was on checkbox
@@ -53,7 +53,7 @@ ContextMenu.prototype = {
             tr.removeClassName('context-menu-selection');
           }
         } else {
-          if (e.ctrlKey) {
+          if (e.ctrlKey || e.metaKey) {
             this.toggleSelection(tr);
           } else if (e.shiftKey) {
             if (this.lastSelected != null) {</code></pre>

I'll merge it tomorrow if there are no naysayers until then.

2011-02-18 09:49 am - Felix Schäfer
- Status changed from Ready for review to Closed

Committed in commit:f4f00e30fda2d149a256a328fcac8276c34d54bf.

2011-02-27 10:09 pm - Eric Davis
- Target version set to 1.1.0 â€” Bell

Files
context_menu.js.patch 518 Bytes 2011-02-11 S C
